@rem Downloaded at https://www.safezone.cc/
@echo off
SetLocal EnableExtensions
cd /d "%~dp0"
title VirusTotal Console Checker & echo VirusTotal check ... & echo.

set vt_cli=vt.exe
set "filepath=%~f1"

if not exist "%vt_cli%" (
  echo vt.exe doesn't found!
  echo Download it at: https://github.com/VirusTotal/vt-cli/releases
  pause & goto :eof
)
if not exist "%UserProfile%\.vt.toml" %vt_cli% init

:enter_path
if not defined filepath (set /p "filepath=Enter file path to check on VT: " & goto enter_path)
if not exist "%filepath%" (echo Cannot found file: "%filepath%" & set "filepath=" & goto enter_path)
echo.
echo Checking file: "%filepath%" ...

echo.
for /f "delims=" %%a in ('%vt_cli% scan file "%filepath%"') do set "result=%%a"
:getid
for /f "tokens=1* delims= " %%a in ("%result%") do set "result=%%b" & if not defined result (set id=%%a) else (goto getid)
echo Got file ID: "%id%"

::in case file already scanned
%vt_cli% analysis %id% > vt.log
< vt.log find /i "completed" && goto parse
< vt.log find /i "status:"
echo Waiting for analysis ...

timeout /t 20 >NUL

:wait_queue
  timeout /t 5 >NUL
  %vt_cli% analysis %id% > vt.log
  < vt.log find /i "queued" && goto wait_queue

:parse
set "is_malicious="
set "is_suspicious="
set "is_failure="
set "is_timeout="
set "is_stats="
echo.
for /f tokens^=1^,2*^ delims^=^"^  %%a in (vt.log) do (
  if defined is_malicious (
    if "%%a"=="engine_name:" <NUL set /p "n=! MALICIOUS: %%b: "
	if "%%a"=="result:" (echo "%%b"& set "is_malicious=")
  )
  if defined is_suspicious (
    if "%%a"=="engine_name:" <NUL set /p "n=! SUSPICIOUS: %%b: "
	if "%%a"=="result:" (echo "%%b"& set "is_suspicious=")
  )
  if defined is_timeout (
    if "%%a"=="engine_name:" (echo %%b ^(timeout^)& set "is_timeout=")
  )
  if defined is_failure (
    if "%%a"=="engine_name:" (echo %%b ^(failure^)& set "is_failure=")
  )
  if defined is_stats echo %%a %%b
  if "%%a"=="category:" if "%%b"=="malicious" set "is_malicious=true"
  if "%%a"=="category:" if "%%b"=="suspicious" set "is_suspicious=true"
  if "%%a"=="category:" if "%%b"=="failure" set "is_failure=true"
  if "%%a"=="category:" if "%%b"=="timeout" set "is_timeout=true"
  if "%%a"=="category:" if "%%b"=="confirmed-timeout" set "is_timeout=true"
  if "%%a"=="stats:" (set "is_stats=true" & echo.)
)
del vt.log

:sel
echo.
echo 1. Open logfile with extended info.
echo 2. Exit
choice /C 12 /N
if %errorlevel%==1 call :details
if %errorlevel%==2 goto :eof
goto sel

:details
for /f "delims=" %%a in ('certutil -hashfile "%filepath%" SHA256 ^| find /v "hash"') do set "hash=%%a"
set "hash=%hash: =%"
echo Checksum SHA256: "%hash%"
vt file %hash% > details.log
start "" details.log
echo details.log is created and opened.
exit /b
